## GstBaseParse GstBaseParse — Base class for stream parsers |

## Functions

void | gst_base_parse_merge_tags ()
void | gst_base_parse_set_duration ()
void | gst_base_parse_set_average_bitrate ()
void | gst_base_parse_set_min_frame_size ()
void | gst_base_parse_set_passthrough ()
void | gst_base_parse_set_syncable ()
void | gst_base_parse_set_has_timing_info ()
void | gst_base_parse_drain ()
void | gst_base_parse_set_frame_rate ()
void | gst_base_parse_set_latency ()
void | gst_base_parse_set_infer_ts ()
void | gst_base_parse_set_pts_interpolation ()
void | gst_base_parse_set_ts_at_offset ()
gboolean | gst_base_parse_convert_default ()
gboolean | gst_base_parse_add_index_entry ()
GstBaseParseFrame * | gst_base_parse_frame_new ()
void | gst_base_parse_frame_init ()
void | gst_base_parse_frame_free ()
GstFlowReturn | gst_base_parse_push_frame ()
GstFlowReturn | gst_base_parse_finish_frame ()
#define | GST_BASE_PARSE_DRAINING()
#define | GST_BASE_PARSE_LOST_SYNC()
#define | GST_BASE_PARSE_SINK_PAD()
#define | GST_BASE_PARSE_SRC_PAD()

## Properties

gboolean | disable-passthrough | Read / Write

## Types and Values

struct | GstBaseParse
struct | GstBaseParseClass
| GstBaseParseFrame
enum | GstBaseParseFrameFlags
#define | GST_BASE_PARSE_FLAG_DRAINING
#define | GST_BASE_PARSE_FLAG_LOST_SYNC
#define | GST_BASE_PARSE_FLOW_DROPPED

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstBaseParse

## Includes

    #include <gst/base/gstbaseparse.h>

## Description

This base class is for parser elements that process data and splits it into separate audio/video/whatever frames.

It provides for:

- provides one sink pad and one source pad

- handles state changes

- can operate in pull mode or push mode

- handles seeking in both modes

- handles events (SEGMENT/EOS/FLUSH)

- handles queries (POSITION/DURATION/SEEKING/FORMAT/CONVERT)

- handles flushing

The purpose of this base class is to provide the basic functionality of a parser and share a lot of rather complex code.

### Description of the parsing mechanism:

#### Set-up phase

- GstBaseParse calls `start` to inform subclass that data processing is about to start now.

- GstBaseParse class calls `set_sink_caps` to inform the subclass about incoming sinkpad caps. Subclass could already set the srcpad caps accordingly, but this might be delayed until calling `gst_base_parse_finish_frame()` with a non-queued frame.

- At least at this point subclass needs to tell the GstBaseParse class how big data chunks it wants to receive (min_frame_size). It can do this with `gst_base_parse_set_min_frame_size()`.

- GstBaseParse class sets up appropriate data passing mode (pull/push) and starts to process the data.

#### Parsing phase

- GstBaseParse gathers at least min_frame_size bytes of data either by pulling it from upstream or collecting buffers in an internal GstAdapter.

- A buffer of (at least) min_frame_size bytes is passed to subclass with `handle_frame` . Subclass checks the contents and can optionally return GST_FLOW_OK along with an amount of data to be skipped to find a valid frame (which will result in a subsequent DISCONT). If, otherwise, the buffer does not hold a complete frame, `handle_frame` can merely return and will be called again when additional data is available. In push mode this amounts to an additional input buffer (thus minimal additional latency), in pull mode this amounts to some arbitrary reasonable buffer size increase. Of course, `gst_base_parse_set_min_frame_size()` could also be used if a very specific known amount of additional data is required. If, however, the buffer holds a complete valid frame, it can pass the size of this frame to `gst_base_parse_finish_frame()`. If acting as a converter, it can also merely indicate consumed input data while simultaneously providing custom output data. Note that baseclass performs some processing (such as tracking overall consumed data rate versus duration) for each finished frame, but other state is only updated upon each call to `handle_frame` (such as tracking upstream input timestamp).

  Subclass is also responsible for setting the buffer metadata (e.g. buffer timestamp and duration, or keyframe if applicable). (although the latter can also be done by GstBaseParse if it is appropriately configured, see below). Frame is provided with timestamp derived from upstream (as much as generally possible), duration obtained from configuration (see below), and offset if meaningful (in pull mode).

  Note that `check_valid_frame` might receive any small amount of input data when leftover data is being drained (e.g. at EOS).

- As part of finish frame processing, just prior to actually pushing the buffer in question, it is passed to `pre_push_frame` which gives subclass yet one last chance to examine buffer metadata, or to send some custom (tag) events, or to perform custom (segment) filtering.

- During the parsing process GstBaseParseClass will handle both srcpad and sinkpad events. They will be passed to subclass if `event` or `src_event` callbacks have been provided.

#### Shutdown phase

- GstBaseParse class calls `stop` to inform the subclass that data parsing will be stopped.

Subclass is responsible for providing pad template caps for source and sink pads. The pads need to be named "sink" and "src". It also needs to set the fixed caps on srcpad, when the format is ensured (e.g. when base class calls subclass' `set_sink_caps` function).

This base class uses `GST_FORMAT_DEFAULT` as a meaning of frames. So, subclass conversion routine needs to know that conversion from `GST_FORMAT_TIME` to `GST_FORMAT_DEFAULT` must return the frame number that can be found from the given byte position.

GstBaseParse uses subclasses conversion methods also for seeking (or otherwise uses its own default one, see also below).

Subclass `start` and `stop` functions will be called to inform the beginning and end of data processing.

Things that subclass need to take care of:

- Provide pad templates

- Fixate the source pad caps when appropriate

- Inform base class how big data chunks should be retrieved. This is done with `gst_base_parse_set_min_frame_size()` function.

- Examine data chunks passed to subclass with `handle_frame` and pass proper frame(s) to `gst_base_parse_finish_frame()`, and setting src pad caps and timestamps on frame.

- Provide conversion functions

- Update the duration information with `gst_base_parse_set_duration()`

- Optionally passthrough using `gst_base_parse_set_passthrough()`

- Configure various baseparse parameters using `gst_base_parse_set_average_bitrate()`, `gst_base_parse_set_syncable()` and `gst_base_parse_set_frame_rate()`.

- In particular, if subclass is unable to determine a duration, but parsing (or specs) yields a frames per seconds rate, then this can be provided to GstBaseParse to enable it to cater for buffer time metadata (which will be taken from upstream as much as possible). Internally keeping track of frame durations and respective sizes that have been pushed provides GstBaseParse with an estimated bitrate. A default `convert` (used if not overridden) will then use these rates to perform obvious conversions. These rates are also used to update (estimated) duration at regular frame intervals.

## Functions

### gst_base_parse_merge_tags ()

    void
    gst_base_parse_merge_tags (GstBaseParse *parse,
                               GstTagList *tags,
                               GstTagMergeMode mode);

Sets the parser subclass's tags and how they should be merged with any upstream stream tags. This will override any tags previously-set with `gst_base_parse_merge_tags()`.

Note that this is provided for convenience, and the subclass is not required to use this and can still do tag handling on its own.

#### Parameters

parse | a GstBaseParse |
tags | a GstTagList to merge, or NULL to unset previously-set tags. | [allow-none]
mode | the GstTagMergeMode to use, usually GST_TAG_MERGE_REPLACE |

Since: 1.6

### gst_base_parse_set_duration ()

    void
    gst_base_parse_set_duration (GstBaseParse *parse,
                                 GstFormat fmt,
                                 gint64 duration,
                                 gint interval);

Sets the duration of the currently playing media. Subclass can use this when it is able to determine duration and/or notices a change in the media duration. Alternatively, if `interval` is non-zero (default), then stream duration is determined based on estimated bitrate, and updated every `interval` frames.

#### Parameters

parse | GstBaseParse. |
fmt | GstFormat. |
duration | duration value. |
interval | how often to update the duration estimate based on bitrate, or 0. |

### gst_base_parse_set_average_bitrate ()

    void
    gst_base_parse_set_average_bitrate (GstBaseParse *parse,
                                        guint bitrate);

Optionally sets the average bitrate detected in media (if non-zero), e.g. based on metadata, as it will be posted to the application.

By default, announced average bitrate is estimated. The average bitrate is used to estimate the total duration of the stream and to estimate a seek position, if there's no index and the format is syncable (see `gst_base_parse_set_syncable()`).

#### Parameters

parse | GstBaseParse. |
bitrate | average bitrate in bits/second |

### gst_base_parse_set_min_frame_size ()

    void
    gst_base_parse_set_min_frame_size (GstBaseParse *parse,
                                       guint min_size);

Subclass can use this function to tell the base class that it needs to give at least min_size buffers.

#### Parameters

parse | GstBaseParse. |
min_size | Minimum size of the data that this base class should give to subclass. |

### gst_base_parse_set_passthrough ()

    void
    gst_base_parse_set_passthrough (GstBaseParse *parse,
                                    gboolean passthrough);

Set if the nature of the format or configuration does not allow (much) parsing, and the parser should operate in passthrough mode (which only applies when operating in push mode). That is, incoming buffers are pushed through unmodified, i.e. no `check_valid_frame` or `parse_frame` callbacks will be invoked, but `pre_push_frame` will still be invoked, so subclass can perform as much or as little is appropriate for passthrough semantics in `pre_push_frame` .

#### Parameters

parse | a GstBaseParse |
passthrough | `TRUE` if parser should run in passthrough mode |

### gst_base_parse_set_syncable ()

    void
    gst_base_parse_set_syncable (GstBaseParse *parse,
                                 gboolean syncable);

Set if frame starts can be identified. This is set by default and determines whether seeking based on bitrate averages is possible for a format/stream.

#### Parameters

parse | a GstBaseParse |
syncable | set if frame starts can be identified |

### gst_base_parse_set_has_timing_info ()

    void
    gst_base_parse_set_has_timing_info (GstBaseParse *parse,
                                        gboolean has_timing);

Set if frames carry timing information which the subclass can (generally) parse and provide. In particular, intrinsic (rather than estimated) time can be obtained following a seek.

#### Parameters

parse | a GstBaseParse |
has_timing | whether frames carry timing information |

### gst_base_parse_drain ()

    void
    gst_base_parse_drain (GstBaseParse *parse);

Drains the adapter until it is empty. It decreases the min_frame_size to match the current adapter size and calls chain method until the adapter is emptied or chain returns with error.

#### Parameters

parse | a GstBaseParse |

Since: 1.12

### gst_base_parse_set_frame_rate ()

    void
    gst_base_parse_set_frame_rate (GstBaseParse *parse,
                                   guint fps_num,
                                   guint fps_den,
                                   guint lead_in,
                                   guint lead_out);

If frames per second is configured, parser can take care of buffer duration and timestamping. When performing segment clipping, or seeking to a specific location, a corresponding decoder might need an initial `lead_in` and a following `lead_out` number of frames to ensure the desired segment is entirely filled upon decoding.

#### Parameters

parse | the GstBaseParse to set |
fps_num | frames per second (numerator). |
fps_den | frames per second (denominator). |
lead_in | frames needed before a segment for subsequent decode |
lead_out | frames needed after a segment |

### gst_base_parse_set_latency ()

    void
    gst_base_parse_set_latency (GstBaseParse *parse,
                                GstClockTime min_latency,
                                GstClockTime max_latency);

Sets the minimum and maximum (which may likely be equal) latency introduced by the parsing process. If there is such a latency, which depends on the particular parsing of the format, it typically corresponds to 1 frame duration.

#### Parameters

parse | a GstBaseParse |
min_latency | minimum parse latency |
max_latency | maximum parse latency |

### gst_base_parse_set_infer_ts ()

    void
    gst_base_parse_set_infer_ts (GstBaseParse *parse,
                                 gboolean infer_ts);

By default, the base class might try to infer PTS from DTS and vice versa. While this is generally correct for audio data, it may not be otherwise. Sub-classes implementing such formats should disable timestamp inferring.

#### Parameters

parse | a GstBaseParse |
infer_ts | `TRUE` if parser should infer DTS/PTS from each other |

### gst_base_parse_set_pts_interpolation ()

    void
    gst_base_parse_set_pts_interpolation (GstBaseParse *parse,
                                          gboolean pts_interpolate);

By default, the base class will guess PTS timestamps using a simple interpolation (previous timestamp + duration), which is incorrect for data streams with reordering, where PTS can go backward. Sub-classes implementing such formats should disable PTS interpolation.

#### Parameters

parse | a GstBaseParse |
pts_interpolate | `TRUE` if parser should interpolate PTS timestamps |

### gst_base_parse_set_ts_at_offset ()

    void
    gst_base_parse_set_ts_at_offset (GstBaseParse *parse,
                                     gsize offset);

This function should only be called from a `handle_frame` implementation.

GstBaseParse creates initial timestamps for frames by using the last timestamp seen in the stream before the frame starts. In certain cases, the correct timestamps will occur in the stream after the start of the frame, but before the start of the actual picture data. This function can be used to set the timestamps based on the offset into the frame data that the picture starts.

#### Parameters

parse | a GstBaseParse |
offset | offset into current buffer |

Since: 1.2

### gst_base_parse_convert_default ()

    gboolean
    gst_base_parse_convert_default (GstBaseParse *parse,
                                    GstFormat src_format,
                                    gint64 src_value,
                                    GstFormat dest_format,
                                    gint64 *dest_value);

Default implementation of "convert" vmethod in GstBaseParse class.

#### Parameters

parse | GstBaseParse. |
src_format | GstFormat describing the source format. |
src_value | Source value to be converted. |
dest_format | GstFormat defining the converted format. |
dest_value | Pointer where the conversion result will be put. | [out]

#### Returns

`TRUE` if conversion was successful.

### gst_base_parse_add_index_entry ()

    gboolean
    gst_base_parse_add_index_entry (GstBaseParse *parse,
                                    guint64 offset,
                                    GstClockTime ts,
                                    gboolean key,
                                    gboolean force);

Adds an entry to the index associating `offset` to `ts` . It is recommended to only add keyframe entries. `force` allows to bypass checks, such as whether the stream is (upstream) seekable, another entry is already "close" to the new entry, etc.

#### Parameters

parse | GstBaseParse. |
offset | offset of entry |
ts | timestamp associated with offset |
key | whether entry refers to keyframe |
force | add entry disregarding sanity checks |

#### Returns

gboolean indicating whether entry was added

### gst_base_parse_frame_new ()

    GstBaseParseFrame *
    gst_base_parse_frame_new (GstBuffer *buffer,
                              GstBaseParseFrameFlags flags,
                              gint overhead);

Allocates a new GstBaseParseFrame. This function is mainly for bindings, elements written in C should usually allocate the frame on the stack and then use `gst_base_parse_frame_init()` to initialise it.

#### Parameters

buffer | a GstBuffer. | [transfer none]
flags | the flags |
overhead | number of bytes in this frame which should be counted as metadata overhead, ie. not used to calculate the average bitrate. Set to -1 to mark the entire frame as metadata. If in doubt, set to 0. |

#### Returns

a newly-allocated GstBaseParseFrame. Free with `gst_base_parse_frame_free()` when no longer needed.

### gst_base_parse_frame_init ()

    void
    gst_base_parse_frame_init (GstBaseParseFrame *frame);

Sets a GstBaseParseFrame to initial state. Currently this means all public fields are zero-ed and a private flag is set to make sure `gst_base_parse_frame_free()` only frees the contents but not the actual frame. Use this function to initialise a GstBaseParseFrame allocated on the stack.

#### Parameters

frame | GstBaseParseFrame. |

### gst_base_parse_frame_free ()

    void
    gst_base_parse_frame_free (GstBaseParseFrame *frame);

### gst_base_parse_push_frame ()

    GstFlowReturn
    gst_base_parse_push_frame (GstBaseParse *parse,
                               GstBaseParseFrame *frame);

Pushes the frame's buffer downstream, sends any pending events and does some timestamp and segment handling. Takes ownership of frame's buffer, though caller retains ownership of `frame` .

This must be called with sinkpad STREAM_LOCK held.

#### Parameters

parse | GstBaseParse. |
frame | a GstBaseParseFrame. | [transfer none]

#### Returns

GstFlowReturn

### gst_base_parse_finish_frame ()

    GstFlowReturn
    gst_base_parse_finish_frame (GstBaseParse *parse,
                                 GstBaseParseFrame *frame,
                                 gint size);

Collects parsed data and pushes this downstream. Source pad caps must be set when this is called.

If `frame` 's out_buffer is set, that will be used as subsequent frame data. Otherwise, `size` samples will be taken from the input and used for output, and the output's metadata (timestamps etc) will be taken as (optionally) set by the subclass on `frame` 's (input) buffer (which is otherwise ignored for any but the above purpose/information).

Note that the latter buffer is invalidated by this call, whereas the caller retains ownership of `frame` .

#### Parameters

parse | a GstBaseParse |
frame | a GstBaseParseFrame |
size | consumed input data represented by frame |

#### Returns

a GstFlowReturn that should be escalated to caller (of caller)

### GST_BASE_PARSE_DRAINING()

    #define GST_BASE_PARSE_DRAINING(parse)  (!!(GST_BASE_PARSE_CAST(parse)->flags & GST_BASE_PARSE_FLAG_DRAINING))

Obtains current drain status (ie. whether EOS has been received and the parser is now processing the frames at the end of the stream)

#### Parameters

parse | base parse instance |

### GST_BASE_PARSE_LOST_SYNC()

    #define GST_BASE_PARSE_LOST_SYNC(parse) (!!(GST_BASE_PARSE_CAST(parse)->flags & GST_BASE_PARSE_FLAG_LOST_SYNC))

Obtains current sync status.

#### Parameters

parse | base parse instance |

### GST_BASE_PARSE_SINK_PAD()

    #define GST_BASE_PARSE_SINK_PAD(obj)    (GST_BASE_PARSE_CAST (obj)->sinkpad)

Gives the pointer to the sink GstPad object of the element.

#### Parameters

obj | base parse instance |

### GST_BASE_PARSE_SRC_PAD()

    #define GST_BASE_PARSE_SRC_PAD(obj)    (GST_BASE_PARSE_CAST (obj)->srcpad)

Gives the pointer to the source GstPad object of the element.

#### Parameters

obj | base parse instance |

## Types and Values

### struct GstBaseParse

    struct GstBaseParse {
      GstElement     element;
    };

The opaque GstBaseParse data structure.

#### Members

GstElement `element`; | the parent element. |

### struct GstBaseParseClass

    struct GstBaseParseClass {
      GstElementClass parent_class;

      /* virtual methods for subclasses */

      gboolean      (*start)              (GstBaseParse * parse);

      gboolean      (*stop)               (GstBaseParse * parse);

      gboolean      (*set_sink_caps)      (GstBaseParse * parse,
                                           GstCaps      * caps);

      GstFlowReturn (*handle_frame)       (GstBaseParse      * parse,
                                           GstBaseParseFrame * frame,
                                           gint              * skipsize);

      GstFlowReturn (*pre_push_frame)     (GstBaseParse      * parse,
                                           GstBaseParseFrame * frame);

      gboolean      (*convert)            (GstBaseParse * parse,
                                           GstFormat      src_format,
                                           gint64         src_value,
                                           GstFormat      dest_format,
                                           gint64       * dest_value);

      gboolean      (*sink_event)         (GstBaseParse * parse,
                                           GstEvent     * event);

      gboolean      (*src_event)          (GstBaseParse * parse,
                                           GstEvent     * event);

      GstCaps *     (*get_sink_caps)      (GstBaseParse * parse,
                                           GstCaps      * filter);

      GstFlowReturn (*detect)             (GstBaseParse * parse,
                                           GstBuffer    * buffer);

      gboolean      (*sink_query)         (GstBaseParse * parse,
                                           GstQuery     * query);

      gboolean      (*src_query)          (GstBaseParse * parse,
                                           GstQuery     * query);
    };

Subclasses can override any of the available virtual methods or not, as needed. At minimum `handle_frame` needs to be overridden.

#### Members

`start` () | Optional. Called when the element starts processing. Allows opening external resources. |
`stop` () | Optional. Called when the element stops processing. Allows closing external resources. |
`set_sink_caps` () | Optional. Allows the subclass to be notified of the actual caps set. |
`handle_frame` () | Parses the input data into valid frames as defined by subclass which should be passed to `gst_base_parse_finish_frame()`. The frame's input buffer is guaranteed writable, whereas the input frame ownership is held by caller (so subclass should make a copy if it needs to hang on). Input buffer (data) is provided by baseclass with as much metadata set as possible by baseclass according to upstream information and/or subclass settings, though subclass may still set buffer timestamp and duration if desired. |
`pre_push_frame` () | Optional. Called just prior to pushing a frame (after any pending events have been sent) to give subclass a chance to perform additional actions at this time (e.g. tag sending) or to decide whether this buffer should be dropped or not (e.g. custom segment clipping). |
`convert` () | Optional. Convert between formats. |
`sink_event` () | Optional. Event handler on the sink pad. This function should chain up to the parent implementation to let the default handler run. |
`src_event` () | Optional. Event handler on the source pad. Should chain up to the parent to let the default handler run. |
`get_sink_caps` () | Optional. Allows the subclass to do its own sink get caps if needed. |
`detect` () | Optional. Called until it doesn't return GST_FLOW_OK anymore for the first buffers. Can be used by the subclass to detect the stream format. |
`sink_query` () | Optional. Query handler on the sink pad. This function should chain up to the parent implementation to let the default handler run (Since 1.2) |
`src_query` () | Optional. Query handler on the source pad. Should chain up to the parent to let the default handler run (Since 1.2) |

### GstBaseParseFrame

    typedef struct {
      GstBuffer * buffer;
      GstBuffer * out_buffer;
      guint       flags;
      guint64     offset;
      gint        overhead;
    } GstBaseParseFrame;

Frame (context) data passed to each frame parsing virtual methods. In addition to providing the data to be checked for a valid frame or an already identified frame, it conveys additional metadata or control information from and to the subclass w.r.t. the particular frame in question (rather than global parameters). Some of these may apply to each parsing stage, others only to some a particular one. These parameters are effectively zeroed at start of each frame's processing, i.e. parsing virtual method invocation sequence.

#### Members

GstBuffer *`buffer`; | input data to be parsed for frames. |
GstBuffer *`out_buffer`; | output data. |
guint `flags`; | a combination of input and output GstBaseParseFrameFlags that convey additional context to subclass or allow subclass to tune subsequent GstBaseParse actions. |
guint64 `offset`; | media specific offset of input frame Note that a converter may have a different one on the frame's buffer. |
gint `overhead`; | subclass can set this to indicates the metadata overhead for the given frame, which is then used to enable more accurate bitrate computations. If this is -1, it is assumed that this frame should be skipped in bitrate calculation. |

### enum GstBaseParseFrameFlags

Flags to be used in a GstBaseParseFrame.

#### Members

GST_BASE_PARSE_FRAME_FLAG_NONE | no flag |
GST_BASE_PARSE_FRAME_FLAG_NEW_FRAME | set by baseclass if current frame is passed for processing to the subclass for the first time (and not set on subsequent calls with same data). |
GST_BASE_PARSE_FRAME_FLAG_NO_FRAME | set to indicate this buffer should not be counted as frame, e.g. if this frame is dependent on a previous one. As it is not counted as a frame, bitrate increases but frame to time conversions are maintained. |
GST_BASE_PARSE_FRAME_FLAG_CLIP | `pre_push_frame` can set this to indicate that regular segment clipping can still be performed (as opposed to any custom one having been done). |
GST_BASE_PARSE_FRAME_FLAG_DROP | indicates to `finish_frame` that the the frame should be dropped (and might be handled internally by subclass) |
GST_BASE_PARSE_FRAME_FLAG_QUEUE | indicates to `finish_frame` that the the frame should be queued for now and processed fully later when the first non-queued frame is finished |

### GST_BASE_PARSE_FLAG_DRAINING

    #define GST_BASE_PARSE_FLAG_DRAINING  (1 << 1)

### GST_BASE_PARSE_FLAG_LOST_SYNC

    #define GST_BASE_PARSE_FLAG_LOST_SYNC (1 << 0)

### GST_BASE_PARSE_FLOW_DROPPED

    #define GST_BASE_PARSE_FLOW_DROPPED     GST_FLOW_CUSTOM_SUCCESS

A GstFlowReturn that can be returned from parse_frame to indicate that no output buffer was generated, or from pre_push_frame to to forego pushing buffer.

## Property Details

### The `“disable-passthrough”` property

      “disable-passthrough”      gboolean

If set to `TRUE`, baseparse will unconditionally force parsing of the incoming data. This can be required in the rare cases where the incoming side-data (caps, pts, dts, ...) is not trusted by the user and wants to force validation and parsing of the incoming data. If set to `FALSE`, decision of whether to parse the data or not is up to the implementation (standard behaviour).

Flags: Read / Write

Default value: FALSE

## See Also

GstBaseTransform